#pragma once
#include <luna/Result.h>

class Device
{
  public:
    virtual Result<usize> read(u8* buf, usize offset, usize length) const = 0;

    virtual Result<usize> write(const u8* buf, usize offset, usize length) = 0;

    virtual Result<u64> ioctl(int, void*)
    {
        return err(ENOTTY);
    }

    virtual usize size() const
    {
        return 0;
    }

    virtual bool is_block_device() const
    {
        return false;
    }

    virtual bool blocking() const = 0;

    virtual ~Device() = default;
};
